# -*- coding: utf-8 -*-
"""
###############################################
AgileUFRJ - Implementando as teses do PPGI
###############################################

:Author: *Carlo E. T. Oliveira*
:Contact: carlo@nce.ufrj.br
:Date: $Date: 2009/09/02  $
:Status: This is a "work in progress"
:Revision: $Revision: 0.01 $
:Home: `LABASE `__
:Copyright: ©2009, `GPL 
"""

import tornado.web
import tornado.template
import hashlib
import model
import string

from model import _EMPTYMEMBER, _EMPTYMEMBERFORM, _EMPTYENCONTRO, _EMPTYENCONTROFORM, _EMPTYPROF, _EMPTYPROFFORM, _EMPTYKEYS
from datetime import datetime
from random import choice

MAGIC_KEY = "6yt276Yt197AgR5667dGkLO3"

def GenMagicKey(length=24, chars=string.letters + string.digits):
    return ''.join([choice(chars) for i in range(length)])


class BaseHandler(tornado.web.RequestHandler):
    "teste de usuario corrente"
    def get_current_user(self):
        return self.get_secure_cookie("user")

    def render(self, template_name, USER="", **kwargs):
        if USER == "":
           USER = self.get_current_user()
        super(BaseHandler,self).render(template_name, USER=USER, **kwargs)


class MainHandler(BaseHandler):
    "Mensagem de boas vindas"
    def get(self):
        self.render("home.html", MSG=u"Bem-vindo ao Oi Tonomundo")


class RegistryHandler(BaseHandler):
    ''' Cadastro de novo usuário '''
    def get (self):
        self.render("modules/member/profile-form.html", USERDATA=_EMPTYMEMBER, MSG="")

    def post(self):
        user_data = dict(_EMPTYMEMBER)
        msg = ""
            
        for key in user_data.keys():
            if self.get_argument(key,"") != "" :
                if key == "passwd":
                    passwd = self.get_argument(key)
                    if passwd == self.get_argument("npasswd"):
                        hash = hashlib.md5()
                        hash.update(self.get_argument("user")+passwd)
                        user_data[key] = hash.hexdigest()
                    else:
                        msg += u"* Senha diferente da confirmação!<br/>"
                else:
                    user_data[key] = self.get_argument(key)

        formkeys = _EMPTYMEMBERFORM[:]
        requestkeys = [x for x in self.request.arguments.keys() if x in _EMPTYMEMBERFORM]

        if len(formkeys) != len(requestkeys):
            msg += u"* Há campos obrigatórios não preenchidos!<br/>"

        user = user_data["user"]
        mkey = self.get_argument("mkey","")

        if user != "" and (user in model.MEMBER):
            msg += u"* Login já existe!<br/>"
        elif mkey != MAGIC_KEY and (mkey not in model.MAGKEYS):
            msg += u"* Chave mágica incorreta!<br/>"

        if msg:
            user_data["passwd"] = user_data["npasswd"] = ""
            self.render("modules/member/profile-form.html", USERDATA=user_data, MSG=msg)
        else:
            model.MEMBER[user] = user_data
            magic_data = dict(_EMPTYKEYS)

            for i in range(3):
                magic_data['user'] = user
                magic_data['magic'] = GenMagicKey()
                model.MAGKEYS[magic_data['magic']] = magic_data

            if mkey != MAGIC_KEY:
                model.MAGKEYS.__delitem__(mkey)

            self.redirect("/")


class ProfessorHandler(BaseHandler):
    ''' Cadastro de novo professor '''
    @tornado.web.authenticated
    def get (self):
        if self.get_current_user() in model.PROFESSOR:
            self.render("home.html", MSG=u"Você já se cadastrou anteriormente.")
        else:
            member = model.MEMBER[self.get_current_user()]
            user_data = dict(_EMPTYPROF)
            user_data["user"] = member["user"]
            user_data["name"] = member["name"]
            user_data["lastname"] = member["lastname"]
            self.render("modules/member/prof-form.html", USERDATA=user_data, MSG="")

    @tornado.web.authenticated
    def post(self):
        user_data = dict(_EMPTYPROF)
        msg = ""

        for key in user_data.keys():
            if self.get_argument(key, "") != "" :
                user_data[key] = self.get_argument(key)

        #formkeys = _EMPTYPROFFORM[:]
        #requestkeys = [x for x in self.request.arguments.keys() if x in _EMPTYPROFFORM]
        #
        #if len(formkeys) != len(requestkeys):
        #    msg += u"* Há campos obrigatórios não preenchidos!<br/>"

        user = user_data["user"]

        if user != "" and (user in model.PROFESSOR):
            msg += u"* Usuário já cadastrado!<br/>"

        if msg:
            self.render("modules/member/prof-form.html", USERDATA=user_data, MSG=msg)
        else:
            user_data["data_inscr"] = str(datetime.now())
            model.PROFESSOR[user] = user_data
            self.redirect("/")


class LoginHandler(BaseHandler):
    ''' Autenticação de usuários '''
    def get(self):
        next = self.get_argument("next", "")
        self.render("modules/member/login-form.html", NEXT=next, MSG="")

    def post(self):
        user   = self.get_argument("user", "")
        passwd = self.get_argument("passwd", "")
        next   = self.get_argument("next", "")

        if passwd != "" and user != "":
            hash = hashlib.md5()
            hash.update(user+passwd) 
            passwd = hash.hexdigest()    
            if user in model.MEMBER and model.MEMBER[user]["passwd"] == passwd: 
                # usuário autenticado
#                user_data = dict(_EMPTYMEMBER)
#                user_data.update(model.MEMBER[user])
                if self.get_argument("remember", "0") == "1":
                    self.set_secure_cookie("user", user)
                else:
                    self.set_secure_cookie("user", user, None)

                self.redirect( ("/%s" % user, next)[next!=""] )
            else:
                self.render("modules/member/login-form.html", NEXT=next, MSG=u"Senha incorreta ou usuário inexistente.")
        else:
            self.render("modules/member/login-form.html", NEXT=next, MSG="Senha ou usuário não especificados.")


class LogoutHandler(BaseHandler):
    def get(self):
        self.clear_all_cookies()
        self.render("home.html", USER="", MSG=u"Sessão encerrada.")


class UserHandler(BaseHandler):
    ''' Lista tela principal de um usuário '''
    @tornado.web.authenticated
    def get (self,user_id):
        user_data = dict(_EMPTYMEMBER)
        user_data.update(model.MEMBER[user_id])
        magic_keys = []

        for key in model.MAGKEYS:
            if model.MAGKEYS[key]['user'] == user_id:
                magic_keys.append(key)

        self.render("modules/member/userpage.html", USERDATA=user_data, MAGICKEYS=magic_keys)


class UserProfileHandler(BaseHandler):
    ''' Lista o perfil de um usuário '''
    @tornado.web.authenticated
    def get (self, user_id):
        user_data = dict(_EMPTYMEMBER)
        user_data.update(model.MEMBER[user_id])
        self.render("modules/member/profile.html",USERDATA=user_data)

class EncontroHandler(BaseHandler):
    ''' Formulário de cadastramento no VI Encontro '''
    @tornado.web.authenticated
    def get (self):
        if self.get_current_user() in model.ENCONTRO:
            self.render("home.html", MSG=u"Você já se inscreveu anteriormente.")
        else:
            member = model.MEMBER[self.get_current_user()]
            user_data = dict(_EMPTYENCONTRO)
            user_data["user"] = member["user"]
            user_data["name"] = member["name"]
            user_data["lastname"] = member["lastname"]
            self.render("modules/member/encontro-form.html", USERDATA=user_data, MSG="")
  
    @tornado.web.authenticated
    def post(self):
        user_data = dict(_EMPTYENCONTRO)
        msg = ""

        for key in user_data.keys():
            if key == "tags":
                user_data[key] = self.get_argument(key,"").split(" ")
            else:
                user_data[key] = self.get_argument(key,"")

        formkeys = _EMPTYENCONTROFORM[:]
        requestkeys = [x for x in self.request.arguments.keys() if x in _EMPTYENCONTROFORM]

        if len(formkeys) != len(requestkeys):
            msg += u"* Há campos obrigatórios não preenchidos!<br/>"

        user = user_data["user"]

        if user != "" and (user in model.ENCONTRO):
            msg += u"* Usuário já inscrito!<br/>"

        if msg:
            self.render("modules/member/encontro-form.html", USERDATA=user_data, MSG=msg)
        else:
            user_data["data_inscr"] = str(datetime.now())
            model.ENCONTRO[user] = user_data
            
            if  "tags" in model.TAGS:
                tagsdb = model.TAGS["tags"]
            else:
                tagsdb = {}
            for tag in user_data["tags"]:    
                if tag in tagsdb:
                   tagsdb[tag].append(user_data["user"])
                else:
                   tagsdb[tag] = [user_data["user"]]
            model.TAGS["tags"] = tagsdb
            
            self.render("home.html", MSG=u"Usuário inscrito com sucesso.")

class VotacaoHandler(BaseHandler):
    ''' Formulário de votacao nos inscritos para o VI Encontro '''
    @tornado.web.authenticated
    def get (self):
        #encontro_data = dict(_EMPTYENCONTRO)
        member = model.MEMBER[self.get_current_user()]
        user_data = dict(_EMPTYENCONTRO)
        user_data["user"] = member["user"]
        #todas as tags armazenadas
        tags_data=[]
        for tag in model.TAGS["tags"]:
            if tag != "_id" and tag != "_rev":
                tags_data.append(tag)
                       
        encontro_data = model.ENCONTRO
        user_data["votados"] = encontro_data[user_data["user"]]["votados"]
        print user_data["votados"]
        self.render("modules/member/votacao-form.html", ENCONTRODATA=encontro_data, \
                    USERDATA=user_data, TAGSDATA=tags_data)  


HANDLERS = [
            (r"/",                      MainHandler),
            (r"/login",                 LoginHandler),
            (r"/logout",                LogoutHandler),
            (r"/registry",              RegistryHandler),
            (r"/professor",             ProfessorHandler),
            (r"/encontro",              EncontroHandler),
            (r"/votacao",               VotacaoHandler),
            (r"/(\w+)",                 UserHandler),
            (r"/(\w+)/profile",         UserProfileHandler)
        ]
