# -*- coding: utf-8 -*-
"""
###############################################
AgileUFRJ - Implementando as teses do PPGI
###############################################

:Author: *Carlo E. T. Oliveira*
:Contact: carlo@nce.ufrj.br
:Date: $Date: 2009/09/02  $
:Status: This is a "work in progress"
:Revision: $Revision: 0.01 $
:Home: `LABASE `__
:Copyright: ©2009, `GPL 
"""
from couchdb import Server

_DOCBASES = ['member', 'encontro', 'tags', 'professor', 'magkeys']

_EMPTYMEMBER=dict(
          user=""
        , passwd=""
        , name=""
        , lastname=""
        , email=""
        , photo="0.jpeg"
    )

_EMPTYMEMBERFORM = _EMPTYMEMBER.keys()
_EMPTYMEMBERFORM.remove("photo")
_EMPTYMEMBERFORM.append("npasswd")
_EMPTYMEMBERFORM.append("mkey")

_EMPTYENCONTRO=dict(
          user=""
        , name=""
        , lastname=""
        , telefone=""
        , nome_escola=""
        , telefone_escola=""
        , cidade_escola=""
        , estado_escola=""
        , nome_gestor=""
        , telefone_gestor=""
        , email_gestor=""
        , porque=""
        , tags=[]
        , data_inscr=""
        , votos_recebidos=0
        , votados=[]
    )

_EMPTYENCONTROFORM = _EMPTYENCONTRO.keys()
_EMPTYENCONTROFORM.remove("name")
_EMPTYENCONTROFORM.remove("lastname")
_EMPTYENCONTROFORM.remove("data_inscr")
_EMPTYENCONTROFORM.remove("votos_recebidos")
_EMPTYENCONTROFORM.remove("votados")

_EMPTYPROF=dict(
          user=""
        , name=""
        , lastname=""
        , datanasc=""
        , sexo=""
        , estcivil=""
        , nfilhos=""
        , nacionalidade=""
        , estrangeiro=""
        , naturalidade=""
        , telefone=""
        , celular=""
        , edbasica=""
        , conclusaomedia=""
        , edsuperior=""
        , ies=""
        , iesestado=""
        , curso=""
        , cursotipo=""
        , conclusaosuperior=""
        , tempomagpub=""
        , tempomagpriv=""
        , tempomag=""
        , conhecimentotic=""
        , utilizatic=""
        , apcomerciais=""
        , navinternet=""
        , lprog=""
        , internetcasa=""
        , tipointernetcasa=""
        , internetescola=""
        , tipointernetescola=""
        , internetoutro=""
        , tipointernetoutro=""
        , tempoproj=""
        , questionario=""
        , apresentacao=""
        , msgequipe=""
        , data_inscr=""
    )

_EMPTYPROFFORM = _EMPTYPROF.keys()
_EMPTYPROFFORM.remove("data_inscr")

_EMPTYKEYS=dict(
          user=""
        , magic=""
    )


class Activ(Server):
    "Active database"
    member = {}
    encontro = {}
    tags = {}
    professor = {}
    magkeys = {}

    def __init__(self, url):
        Server.__init__(self, url)
        act = self
        test_and_create = lambda doc: doc in act and act[doc] or act.create(doc)
        for attribute in _DOCBASES:
            setattr(Activ, attribute, test_and_create(attribute))

    def erase_database(self):
        'erase tables'
        for table in _DOCBASES:
            try:
                del self[table]
            except:
                pass


__ACTIV = Activ('http://127.0.0.1:5984/')
MEMBER = __ACTIV.member
ENCONTRO = __ACTIV.encontro
TAGS = __ACTIV.tags
PROFESSOR = __ACTIV.professor
MAGKEYS = __ACTIV.magkeys
