# -*- coding: utf-8 -*-
"""
###############################################
AgileUFRJ - Implementando as teses do PPGI
###############################################

:Author: *Carlo E. T. Oliveira*
:Contact: carlo@nce.ufrj.br
:Date: $Date: 2009/09/02  $
:Status: This is a "work in progress"
:Revision: $Revision: 0.01 $
:Home: `LABASE <http://labase.nce.ufrj.br/>`__
:Copyright: ©2009, `GPL <http://is.gd/3Udt>__. 
"""

from main import WsgiApp
from webtest import TestApp
from webob import Request, Response
from test_cadastro import LOGIN_FORM, REGISTRY_FORM, login, registry
#import mocker
#from mocker import Mocker

import model
import unittest

ENCONTRO_FORM = { "user":"teste",
                  "name": "fulano",
                  "lastname": "de tal",
                  "telefone": "teste",
                  "nome_escola": "teste",
                  "telefone_escola": "teste",                  
                  "cidade_escola": "teste",
                  "estado_escola": "teste",
                  "nome_gestor": "teste",
                  "telefone_gestor": "teste",
                  "email_gestor": "teste",
                  "porque": "teste",                  
                  "tags": "a b c" }

encontro = {}

#class TestCadastro(mocker.MockerTestCase):
class TestCadastro(unittest.TestCase):
  """Testes unitários para o cadastro"""

  def setUp(self):
    #self.mock = Mocker()
    #MEMBER = self.mock.mock()
    model.ENCONTRO = {}
    self.app = TestApp(WsgiApp())
    encontro.update(ENCONTRO_FORM)
    self.app.post('/registry', registry)
    self.app.post('/login', login)

  def tearDown(self):
    #self.mock.restore()
    #self.mock.verify()
    #self.mock,MEMBER =None,None
    pass

  def test_returns_encontro_form_on_root(self):
    "a form containing registry data"
    response = self.app.get('/encontro')
    assert 'Pré-inscrição no VI Encontro Nacional TONOMUNDO' in response, "Erro: Não exibiu formulário de inscrição!"
    assert '<input name="nome_escola" id="nome_escola" value="" type="text"' in response, "Erro: Não exibiu formulário de inscrição!"

  def test_accept_registry_ok(self):
    "test_accept_registry_ok"
    response = self.app.post('/encontro', encontro)
    assert u'Usuário inscrito com sucesso.' in response, "Erro: Inscrição não realizada!"

  def test_reject_registry_double_user(self):
    "test_reject_registry_double_user"
    self.app.post('/encontro', encontro)
    response = self.app.post('/encontro', encontro)
    assert u'Usuário já inscrito!' in response, "Erro: Não exibiu a mensagem 'Usuário já inscrito!'"

  def test_reject_registry_without_required_field(self):
    "test_reject_registry_without_required_field"
    encontro["telefone"]=""
    response = self.app.post('/encontro', encontro)
    assert u'Há campos obrigatórios não preenchidos!' in response, "Erro: Não exibiu a mensagem 'Há campos obrigatórios não preenchidos!'"
